declare type DefaultError = string;
/**
 * @deprecated This will be removed in the next major version.
 */
export declare const RemoteDataTags: {
    readonly NotAsked: "NotAsked";
    readonly InProgress: "InProgress";
    readonly Failure: "Failure";
    readonly Success: "Success";
};
export declare class NotAsked {
    readonly tag = "NotAsked";
    private constructor();
    /**
     * @deprecated This will be removed in the next major version, use the `notAsked()` constructor function instead.
     * @see notAsked
     */
    static of<T, E = DefaultError>(): RemoteData<T, E>;
}
export declare class InProgress<T> {
    private val?;
    readonly tag = "InProgress";
    private constructor();
    /**
     * @deprecated This will be removed in the next major version, use the `inProgress()` constructor function instead.
     * @see inProgress
     */
    static of<T, E = DefaultError>(value?: T): RemoteData<T, E>;
    value(): T | undefined;
}
export declare class Failure<E, T> {
    private err;
    private val?;
    readonly tag = "Failure";
    private constructor();
    /**
     * @deprecated This will be removed in the next major version, use the `failure()` constructor function instead.
     * @see failure
     */
    static of<T, E = DefaultError>(err: E, val?: T): RemoteData<T, E>;
    value(): T | undefined;
    error(): E;
}
export declare class Success<T> {
    private val;
    readonly tag = "Success";
    private constructor();
    /**
     * @deprecated This will be removed in the next major version, use the `success()` constructor function instead.
     * @see success
     */
    static of<T, E = DefaultError>(value: T): RemoteData<T, E>;
    value(): T;
}
export declare const notAsked: <T, E = string>() => RemoteData<T, E>;
export declare const inProgress: <T, E = string>(value?: T | undefined) => RemoteData<T, E>;
export declare const failure: <T, E = string>(err: E, val?: T | undefined) => RemoteData<T, E>;
export declare const success: <T, E = string>(value: T) => RemoteData<T, E>;
export declare const isNotAsked: <T, E>(value: unknown) => value is NotAsked;
export declare const isInProgress: <T, E>(value: unknown) => value is InProgress<T>;
export declare const isFailure: <T, E>(value: unknown) => value is Failure<E, T>;
export declare const isSuccess: <T, E>(value: unknown) => value is Success<T>;
export declare const isRemoteData: <T, E = string>(value: unknown) => value is RemoteData<T, E>;
export declare const fold: <T, E>(onNotAsked: () => T, onInProgress: (value: T | undefined) => T, onFailure: (error: E, value: T | undefined) => T, onSuccess: (value: T) => T, rd: RemoteData<T, E>) => T;
export declare const getOrElse: <T, E>(rd: RemoteData<T, E>, defaultValue: T) => T;
export declare const map: <A, B, E>(fn: (a: A) => B, rd: RemoteData<A, E>) => RemoteData<B, E>;
export declare const mapFailure: <A, E, F>(fn: (e: E) => F, rd: RemoteData<A, E>) => RemoteData<A, F>;
export declare type RemoteData<T, E = string> = NotAsked | InProgress<T> | Failure<E, T> | Success<T>;
/**
 * @deprecated This type will be removed in the next major version
 */
export declare type AnyRemoteData = RemoteData<any, any>;
export {};
//# sourceMappingURL=remote-data.d.ts.map